///////////////////////////////////////////////
//Lösung zu Aufgabe 5 im Kapitel Turtlegrafik
////////////////////////////////////////////////


// Zustand der Turtle
float actX; // aktuelle Position
float actY;
float actW; // aktueller Winkel
color actC;  // aktuelle Farbe
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=1100;
int h=1100;

// Ausgangsseitenlänge des Quadats
int laenge = 150;
int depth = 1;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  colorMode(HSB,360);
  setColor(color(120,360,360));//gruen
}

///////////////////////////////////////////////////////////

void draw() {
  background(0,0,0);
  translate(550,height-100); 
  penDown();
  turn(90);
  tree(depth,laenge);
  
  noLoop();
}

///////////////////////////////////////////////////////////

void keyPressed() {
 if (key == 's') save("binärbaum.png");
 if (key=='+') { if (depth<11) depth++; } //depth < 10 testen!
 if (key=='-') { if (depth>1 ) depth--; }
 redraw();
}

///////////////////////////////////////////////////////////

void tree(int tiefe,int laenge) {
 
  // am Ende der Rekursion mache nichts mehr
  if (tiefe!=0) { 
   
    move(laenge);
    turn(20);  
    tree(tiefe-1,int(0.9*laenge));
    
    turn(10);  
    tree(tiefe-1,int(0.9*laenge));
    
    turn(-50);
    tree(tiefe-1,int(0.9*laenge));
    
    turn(-10);
    tree(tiefe-1,int(0.9*laenge));
    
    turn(30); 
    move(-laenge);//...und zurück
    println(laenge);//zur Kontrolle!
  }
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void move(float len) {
  if (penIsDown) {line(0,0,len,0);}
     
     translate(len,0);
}

void turn(float ang) { rotate(radians(-ang)); }
void setColor(color c) { stroke(c); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }